package dev.thebread

import java.sql.DriverManager
import java.sql.Connection
import java.io.File
import java.sql.PreparedStatement

import dev.thebread.Model.PreparedStatementCase

class KlistApp {

    private var conn: Connection

    constructor(path: String?) {
        conn = DriverManager.getConnection(if (!path.isNullOrBlank()) path else "jdbc:sqlite::memory:")
        dbSetup(conn)
        Model.Common.stmts = dbPrepare(conn)
    }

    private fun dbSetup(conn: Connection) {
        val initSql = javaClass.getResource("/init.sql")!!.readText()
        conn.createStatement().executeUpdate(initSql)
    }

    private fun dbPrepare(conn: Connection): Map<PreparedStatementCase, PreparedStatement> {
        return PreparedStatementCase.entries.associateWith { case ->
            conn.prepareStatement(
                javaClass.getResource("/prepare/${
                    case.toString().lowercase()
                }.sql")!!.readText()
            )
        }
    }

    private fun assureUser() {}
    private fun assureListForUser() {}
    private fun assureStageForList() {}

    public fun createTask() {}
    public fun moveTask() {}
    public fun deleteTask() {}

    public fun createStage() {}
    public fun moveStage() {}
    public fun deleteStage() {}

    public fun deleteUser() {}
}

fun main() {
    val app = KlistApp(null);
    println("Works yay")
}